"use strict";
const EXPORTED_SYMBOLS = ["installInfo"];
const {
    classes: Cc,
    interfaces: Ci,
    utils: Cu
} = Components;
Cu.import("resource://gre/modules/Services.jsm");
Cu.import("resource://gre/modules/AddonManager.jsm");
const installInfo = {
    init: function (application) {
        this._app = application;
    },
    wasInternalUpdate: function (callback) {
        AddonManager.getAddonByID(this._app.id, addon => callback(!this._isAddonFromExternalSource(addon)));
    },
    _isAddonFromExternalSource: function (addon) {
        return Boolean(addon && addon.sourceURI && this._isExternalSourceUri(addon.sourceURI));
    },
    _isExternalSourceUri: function (uri) {
        return uriChecker.isYandex(uri) || uriChecker.isAddonsMozilla(uri) || uriChecker.isFile(uri);
    }
};
const uriChecker = {
    isFile: function (uri) {
        return uri.scheme === "file";
    },
    isYandex: function (uri) {
        try {
            return /^https?$/i.test(uri.scheme) && /^yandex\./i.test(Services.eTLD.getBaseDomain(uri));
        } catch (e) {
        }
        return false;
    },
    isAddonsMozilla: function (uri) {
        try {
            return Services.eTLD.getBaseDomain(uri, 1) === "addons.mozilla.org";
        } catch (e) {
        }
        return false;
    }
};